﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=7.8
@EndOfDesignText@
'Static code module
Sub Process_Globals
	Private fx As JFX
	Private JDKPath As String
End Sub

Public Sub SetEllipses(Lbl As JavaObject)
	Lbl.Runmethod("setTextOverrun",Array("CENTER_ELLIPSIS"))
End Sub

Public Sub SetTooltipTextSize(N As JavaObject, Size As Double)
	Try
		Dim F As Font = fx.DefaultFont(13)
		Dim Tooltip As JavaObject = N.RunMethod("getTooltip",Null)
		Tooltip.RunMethod("setFont",Array(F))
	Catch
		Log(LastException)
	End Try
End Sub

'Set a shortcut key for this menu item
'Returns the menu item
Public Sub SetShortCutKey(MI As JavaObject,Combination() As String) As MenuItem
	Dim KC As JavaObject
	KC.InitializeStatic("javafx.scene.input.KeyCombination")
	Dim KCS As String
	For i = 0 To Combination.Length - 1
		If i > 0 Then KCS = KCS & "+"
		KCS = KCS & Combination(i)
	Next
	MI.RunMethod("setAccelerator",Array(KC.RunMethod("keyCombination",Array(KCS))))
	Return MI
End Sub

Public Sub JDKPathExists As Boolean
	Dim jHome As String = GetSystemProperty("java.home", "")
	If File.Exists(jHome, "../bin/jar.exe") Then
		JDKPath = File.Combine(jHome, "../bin/jar.exe")
		Return True
	Else
		If jHome.EndsWith("jre") = False Then jHome = jHome.Replace("jre","jdk")
		If File.Exists(jHome, "/bin/jar.exe") Then
			JDKPath = File.Combine(jHome, "bin/jar.exe")
			Return True
		End If
	End If
	Return False
End Sub

Public Sub GetJDKPath As String
	Return JDKPath
End Sub

Public  Sub MeasureTextWidth(Text As String,ThisFont As Font) As Double

	Dim TextObj As JavaObject
	TextObj.InitializeNewInstance("javafx.scene.text.Text",Array(Text))
	TextObj.RunMethod("setFont",Array(ThisFont))
	TextObj.RunMethod("applyCss",Null)
	Dim Bounds As JavaObject
	Bounds = TextObj.RunMethodJO("getLayoutBounds",Null)
	Return Bounds.RunMethod("getWidth",Null)
End Sub

Public Sub SetPadding(View As JavaObject,Size As Double)
	Dim Insets As JavaObject
	Insets.InitializeNewInstance("javafx.geometry.Insets",Array(Size))
	View.RunMethod("setPadding",Array(Insets))
End Sub

Public Sub SetMinSize(Form As JavaObject, Width As Double,Height As Double)
	Dim Stage As JavaObject = Form.getField("stage")
	Stage.RunMethod("setMinWidth",Array(Width))
	Stage.RunMethod("setMinHeight",Array(Height))
End Sub

Public Sub UnzipFile(SourceFile As String, TargetFolder As String)
	File.MakeDir(TargetFolder,"")
	Try
		Dim FIS As JavaObject
		FIS.InitializeNewInstance("java.io.FileInputStream",Array(SourceFile))
		Dim DestFolder As JavaObject
		DestFolder.InitializeNewInstance("java.io.File",Array(TargetFolder))
		
		Dim Buffer(1024) As Byte
		
		Dim ZIS As JavaObject
		ZIS.InitializeNewInstance("java.util.zip.ZipInputStream",Array(FIS))
		
		Dim ZipEntry As JavaObject = ZIS.RunMethod("getNextEntry",Null)
		
		Do While ZipEntry <> Null And ZipEntry.IsInitialized
			If ZipEntry.RunMethod("isDirectory",Null) Then
				File.MakeDir(TargetFolder,ZipEntry.RunMethod("getName",Null))
				ZipEntry = ZIS.RunMethod("getNextEntry",Null)
				Continue
			End If
			Dim NewFile As JavaObject
			NewFile.InitializeNewInstance("java.io.File",Array(File.Combine(TargetFolder,ZipEntry.RunMethod("getName",Null))))
			Dim FOS As JavaObject
			FOS.InitializeNewInstance("java.io.FileOutputStream",Array(NewFile))
			Dim Len As Int = ZIS.RunMethod("read",Array(Buffer))
			Do While Len > 0
				FOS.RunMethod("write",Array(Buffer,0,Len))
				Len = ZIS.RunMethod("read",Array(Buffer))
			Loop
			FOS.RunMethod("close",Null)
			ZipEntry = ZIS.RunMethod("getNextEntry",Null)
		Loop
		ZIS.RunMethod("closeEntry",Null)
		ZIS.RunMethod("close",Null)
		
	Catch
		Log(LastException)
	End Try
End Sub