﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=8
@EndOfDesignText@
#DesignerProperty: Key: BooleanExample, DisplayName: Show Seconds, FieldType: Boolean, DefaultValue: True
#DesignerProperty: Key: TextColor, DisplayName: Text Color, FieldType: Color, DefaultValue: 0xFFFFFFFF, Description: Text color

Sub Class_Globals
	Private FX As JFX
	Private mEventName As String 'ignore
	Private mCallBack As Object 'ignore
	Private mBase As B4XView 'ignore
	Private xui As XUI 'ignore
	
	Private Dialog As B4XDialog
	Private MenuBar1 As MenuBar
	Private AboutClass1 As AboutClass
	Private Version As String = "1.2"
	Private ClassMenu As Menu
	Private BuildDocInternal1 As BuildDocInternal
	Private DD As DragAndDrop
	Private mForm As Form
End Sub

Public Sub Initialize (Callback As Object, EventName As String)
	mEventName = EventName
	mCallBack = Callback
End Sub

'Base type must be Object
Public Sub DesignerCreateView (Base As Object, Lbl As Label, Props As Map)
	mBase = Base
'	Dim clr As Int = xui.PaintOrColorToColor(Props.Get("TextColor")) 'Example of getting a color value from Props
	mBase.LoadLayout("BuildDocCV")
	
	mForm = Props.Get("Form")
	DD.Initialize(Me)
'	DD.MakeDragTarget(mBase,"DropTarget")
	Dialog.Initialize(mForm.RootPane)
	Dialog.OverlayColor = xui.Color_ARGB(100,40,40,40)
	CreateMenu
End Sub

Private Sub Base_Resize (Width As Double, Height As Double)
  
End Sub

Private Sub CreateMenu
	MenuBar1.Menus.Clear
	
	Dim FileMenu As Menu
	FileMenu.Initialize("File","Menu")
	Dim FMI As MenuItem = NewMenuItem("Open","Menu",Array As String("Ctrl","O"))
	FMI.Enabled = False
	FileMenu.MenuItems.Add(FMI)
	FileMenu.MenuItems.Add(NewMenuItem("Save As","Menu",Array As String("Ctrl","S")))
	FileMenu.MenuItems.Add(MenuSeparatorItem)
	FileMenu.MenuItems.Add(NewMenuItem("Export HTML","Menu",Array As String()))
	FileMenu.MenuItems.Add(NewMenuItem("Export BBCode","Menu",Array As String()))

	ClassMenu.Initialize("Classes","ClassMenu")
	
	Dim HelpMenu As Menu
	HelpMenu.Initialize("Help","Menu")
	HelpMenu.MenuItems.Add(NewMenuItem("About","Menu",Array As String("F1")))
	
	MenuBar1.Menus.Addall(Array(FileMenu,ClassMenu,HelpMenu))
	
End Sub

Private Sub NewMenuItem(Text As String, EventName As String,KeyShortCut() As String) As MenuItem
	Dim MI As MenuItem
	MI.Initialize(Text,EventName)
	If KeyShortCut.Length > 0 Then
		SetShortCutKey(MI,KeyShortCut)
	End If
	Return MI
End Sub

'Creates a menu separator item
Public Sub MenuSeparatorItem As Object
	Dim TJO As JavaObject
	TJO.InitializeNewInstance("javafx.scene.control.SeparatorMenuItem",Null)
	Return TJO
End Sub

'Set a shortcut key for this menu item
'Returns the menu item
Public Sub SetShortCutKey(MI As JavaObject,Combination() As String) As MenuItem
	Dim KC As JavaObject
	KC.InitializeStatic("javafx.scene.input.KeyCombination")
	Dim KCS As String
	For i = 0 To Combination.Length - 1
		If i > 0 Then KCS = KCS & "+"
		KCS = KCS & Combination(i)
	Next
	MI.RunMethod("setAccelerator",Array(KC.RunMethod("keyCombination",Array(KCS))))
	Return MI
End Sub
Private Sub ClassMenu_Action
	Dim PageNo As Int = ClassMenu.MenuItems.IndexOf(Sender) + 1
	BuildDocInternal1.PageNo = PageNo
End Sub

Private Sub Menu_Action
	Dim Mi As MenuItem = Sender
	Select Mi.Text
		Case "Open"
			LoadFile
		Case "Save As"
			If ProcessXML.Library.IsInitialized = False Then Return
			
			Dim FC As FileChooser
			FC.Initialize
			FC.InitialDirectory = UserOptions_Static.GetUserOptionDefault("SaveXML",GetSystemProperty("user.home","C:\"))
			FC.Title = "Save XML"
			Dim FN As String = File.GetName(BuildDocInternal1.CurrentFileName)
			Dim FE As String
			Dim Pos As Int = FN.IndexOf(".")
			If Pos > -1 And Pos < FN.Length - 1 Then
				 FE = "." & FN.SubString(Pos + 1)
				 FN = FN.SubString2(0,Pos)
			End If
			Dim NewFN As String = FN
			Dim Count As Int = 1
			Do While File.Exists(FC.InitialDirectory,NewFN & FE)
				NewFN = FN & Count
				Count = Count + 1
			Loop
			Dim InitialFileName As String = NewFN & FE
			
			FC.SetExtensionFilter("XML File",Array("*.xml"))
			FC.InitialFileName = InitialFileName
			Dim fileName As String = FC.ShowSave(mForm)
			If fileName = "" Then Return
			UserOptions_Static.PutUserOption("SaveXML",File.GetFileParent(fileName))
			File.WriteString("",fileName,ProcessXML.GetXML)
		Case "Export BBCode"
			
			Dim L As List = DisplayResults.CreatePages(BuildDocInternal1.LibraryName,DisplayResults.OUTPUTMODE_BBCODEEXPORT,BuildDocInternal1.cbComments.Checked)
			If L.Size = 0 Then Return
			
			Dialog.Title = "Export BBCode"
			Wait For (Dialog.Show("Export current page or all?","Page","All","Cancel")) Complete (Resp As Int)
			If Resp = xui.DialogResponse_Cancel Then Return
			If Resp = xui.DialogResponse_Positive Then
				'Page
				BuildDocInternal1.GetExportBBCodePage(True)
				Return
			End If
			
			Dim DC As DirectoryChooser
			DC.Initialize
			DC.InitialDirectory = UserOptions_Static.GetFilePath("ExportBBCodeAll")
			Dim DirName As String = DC.Show(mForm)
			If DirName = "" Then Return
			
			UserOptions_Static.PutUserOption("ExportBBCodeAll",DirName)
			
			'Export all
			
			Dim PageStr As String
			For i = 0 To L.Size - 1
				Dim Class As ClassType =ProcessXML.Library.Classes.Get(i)
				Dim FN As String
				If Class.ShortName = "" Then
					FN = Class.Name & ".Txt"
				Else
					FN = Class.ShortName & ".Txt"
				End If
				PageStr = L.Get(i)
				File.WriteString(DirName,FN,PageStr)
			Next
			
		Case "Export HTML"
			
			Dim L As List = BuildDocInternal1.AsHTMLList
			
			If L.Size = 0 Then Return
			
			Dim DC As DirectoryChooser
			DC.Initialize
			DC.InitialDirectory = UserOptions_Static.GetFilePath("ExportHTML")
			Dim DirName As String = DC.Show(mForm)
			If DirName = "" Then Return
			
			If File.ListFiles(DirName).Size > 0 Then
				Dialog.Title = "Directory not empty"
				Wait For (Dialog.Show("Directory is not empty, Continue?","Yes","No","")) Complete (Resp As Int)
				If Resp = xui.DialogResponse_Negative Then Return
			End If
			
			UserOptions_Static.PutUserOption("ExportHTML",DirName)
			
			
			
			For Each Page As HTMLPage In L
				File.WriteString(DirName,Page.PageName,Page.Page)
			Next
			Try
				File.WriteString(DirName,BuildDocInternal1.CSSFileName,BuildDocInternal1.CSS)
			Catch
				Log(LastException)
			End Try
			
			Dim Page As HTMLPage = L.Get(0)
			FX.ShowExternalDocument(File.GetUri(DirName,Page.PageName))
			
		Case "About"
			If AboutClass1.IsInitialized = False Then
				AboutClass1.Initialize(mForm,Version)
				Try
					AboutClass1.SetLicence(File.ReadString(File.DirAssets,"licence.txt"))
				Catch
					Log(LastException)
					AboutClass1.SetLicence($"Author Stevel05
			(c) 2020 Stevel05
			
			This code is provided free for the benefit of the B4x Community. If you use this code or a derivitive in a commercial application or benefit financially from the utility, please consider donating to the author to keep the goodwill flowing and encourage the provision of more examples and support.
			
			Click To dismiss"$)
				End Try
			End If
			AboutClass1.Show
	End Select
End Sub

'Download a file that has been dropped from B4xForum
Public Sub DownloadFile(URL As String)
	
	Dim FileName As String
	FileName = URL.SubString2(0,URL.LastIndexOf("."))
	Dim ReplPos As Int = FileName.LastIndexOf("-")
	If ReplPos > -1 Then FileName = FileName.SubString2(0,ReplPos) & "." & FileName.SubString(ReplPos+1)
	FileName = File.GetName(FileName)
	FileName = FileName.SubString2(0,1).ToUpperCase & FileName.SubString(1)
	
	Dialog.Title = "Downloading xml from B4xForum"
	Dim DT As FileDownloadIndeterminate_Template
	DT.Initialize
	DT.Text = FileName
	
	Dialog.ShowTemplate(DT,"","","")

'	Dialog.
	Dim j As HttpJob
	j.Initialize("", Me)
	j.Download(URL)
	Wait For (j) JobDone(j As HttpJob)

	Dim TempDir As String
	If j.Success Then
		Dim joBA As JavaObject
		joBA.InitializeStatic("anywheresoftware.b4a.BA")
		TempDir = File.Combine(File.DirData(joBA.GetField("packageName")),"Temp")
		If File.IsDirectory(TempDir,"") Then RemoveDir(TempDir)
		File.MakeDir(TempDir,"")
		File.WriteString(TempDir,FileName,j.GetString)
	End If
	j.Release
	Dialog.Close(0)
	
	If FileName <> "" Then LoadFileDo(File.Combine(TempDir,FileName))
End Sub

'Iterative sub to remove all files and directories under and including root
Private Sub RemoveDir(Root As String)
	Dim L As List = File.ListFiles(Root)
	For Each S As String In L
		If File.IsDirectory(Root,S) Then
			RemoveDir(File.Combine(Root,S))
		Else
			File.Delete(Root,S)
		End If
	Next
	File.Delete(Root,"")
End Sub

Private Sub LoadFile
	'XML File Open
	Dim FC As FileChooser
	FC.Initialize
	FC.InitialDirectory = UserOptions_Static.GetUserOptionDefault("XMLFileDir",GetSystemProperty("user.home","C:\"))
	FC.Title = "Load XML file"
	FC.SetExtensionFilter("XML File",Array("*.xml"))
	Dim FileName As String = FC.ShowOpen(mForm)
	If FileName = "" Then Return

	UserOptions_Static.PutUserOption("XMLFileDir",File.GetFileParent(FileName))
	
	LoadFileDo(FileName)
End Sub

'Load a file
Public Sub LoadFileDo(FileName As String)
	BuildDocInternal1.LoadFile(FileName)
	
	ClassMenu.MenuItems.Clear
	For Each Class As ClassType In ProcessXML.Library.Classes
		Dim MI As MenuItem = NewMenuItem(Class.Name,"ClassMenu",Array As String())
		ClassMenu.MenuItems.Add(MI)
	Next
End Sub

Public Sub MainForm_CloseRequest (EventData As Event)
	UserOptions_Static.SaveFormMetrics(mForm,"-")
	UserOptions_Static.SaveUserOptions
End Sub

#Region DragDrop
Private Sub DropTarget_DragEntered(e As DragEvent)
	Dim clr As Int
	If IsValidDropEvent(e) Then
		clr = xui.Color_Green
	Else
		clr = xui.Color_Red
	End If
	mBase.SetColorAndBorder(mBase.Color, 4dip, clr, 0)
End Sub

Private Sub DropTarget_DragExited(e As DragEvent)
	mBase.SetColorAndBorder(mBase.Color, 0, 0, 0)
End Sub

Private Sub DropTarget_DragOver(e As DragEvent)
	If IsValidDropEvent(e) Then e.AcceptTransferModes(TransferMode.COPY)
End Sub

Private Sub IsValidDropEvent(e As DragEvent) As Boolean
	If e.GetDragboard.HasFiles Then
		Dim files As List = e.GetDragboard.GetFiles
		If files.Size = 1 Then
			Dim filename As String = files.Get(0)
			Return filename.EndsWith(".xml")
		End If
	Else If e.GetDragboard.HasUrl Then
		Dim URL As String = e.GetDragboard.GetUrl
		URL = URL.SubString2(0,URL.LastIndexOf("."))
		Return URL.StartsWith("https://www.b4x.com/android/forum/attachments/") And URL.EndsWith("xml")
	End If
	Return False
End Sub


Private Sub DropTarget_DragDropped(e As DragEvent)
	Log("drag dropped")
	e.SetDropCompleted(True)
	If e.GetDragboard.HasFiles Then
		Dim files As List = e.GetDragboard.GetFiles
		If files.Size = 1 Then
			Dim filename As String = files.Get(0)
			LoadFileDo(filename)
		End If
	Else If e.GetDragboard.HasUrl Then
		DownloadFile(e.GetDragboard.GetUrl)
	End If
End Sub
#End Region DragDrop