﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=8
@EndOfDesignText@
'#DesignerProperty: Key: BooleanExample, DisplayName: Show Seconds, FieldType: Boolean, DefaultValue: True
'#DesignerProperty: Key: TextColor, DisplayName: Text Color, FieldType: Color, DefaultValue: 0xFFFFFFFF, Description: Text color

Sub Class_Globals
	Private FX As JFX
	Private mEventName As String 'ignore
	Private mCallBack As Object 'ignore
	Private mBase As B4XView 'ignore
	Private xui As XUI 'ignore
	Private BBCodeView1 As BBCodeView
	Private BBLabel1 As BBLabel
	Private Textengine As BCTextEngine
	Private NumberSpinnerCV1 As NumberSpinnerCV
	Private lblPageCount As Label
	Private mCurrentFileName As String
	Public LibraryName As String
	Private CurrentPageNo As Int
	Private mOutputMode As String = "BBCode"
	
	Public cbComments As CheckBox
	Public mForm As Form
	
	Private Dialog As B4XDialog
	Private BBcIndexes As BBCodeView
End Sub

Public Sub Initialize (Callback As Object, EventName As String)
	mEventName = EventName
	mCallBack = Callback
	
	
End Sub

'Base type must be Object
Public Sub DesignerCreateView (Base As Object, Lbl As Label, Props As Map)
	mBase = Base
	
	mBase.LoadLayout("BuildDocInternal")
	NumberSpinnerCV1.MinValue = 1
	
	Dim mForm As Form = Props.Get("Form")
	Textengine.Initialize(mForm.RootPane)
	Textengine.DefaultFont = xui.CreateDefaultFont(12)
	Textengine.CustomFonts.Put("italic",xui.CreateFont(FX.CreateFont("System", 10, False, True), 10))
	Dialog.Initialize(mForm.RootPane)
	Dim SVN As ScrollPane =	BBcIndexes.sv
	SVN.SetVScrollVisibility("NEVER")

End Sub

Private Sub Base_Resize (Width As Double, Height As Double)

End Sub

'Set the current page number
Public Sub setPageNo(PageNo As Int)
	CurrentPageNo = PageNo
	BBcIndexes.Text =  DisplayResults.GetWorkingBookmarks(CurrentPageNo)
	BBCodeView1.Text =  DisplayResults.GetPage(PageNo)
	BBCodeView1.sv.ScrollViewOffsetY = 0
	NumberSpinnerCV1.Value = PageNo
End Sub

'Get the text of the current page
Public Sub getPage(PageNo As String) As String
	Return  DisplayResults.GetPage(CurrentPageNo)
End Sub

'Load a new file
Public Sub LoadFile(FileName As String)
	
	Dim Result As Int = ProcessXML.Process2(FileName)
	Select Result
		Case ProcessXML.PARSE_XMLNOTB4XLIB
			Dialog.Title = "Not a B4x Library"
			Wait For(Dialog.Show("Could not parse this file","OK","","")) Complete (resp As Int)
			ClearData
			Return
		Case ProcessXML.PARSE_XMLNOTVALID
			Dialog.Title = "XML not valid"
			Wait For(Dialog.Show("Could not parse this file","OK","","")) Complete (resp As Int)
			ClearData
			Return
	End Select
	
	CurrentPageNo = 0
	mCurrentFileName = FileName
	LibraryName = File.GetName(mCurrentFileName.SubString2(0,mCurrentFileName.LastIndexOf(".")))
	
	DisplayResults.CreatePages(LibraryName,mOutputMode,cbComments.Checked)
	
'	If DisplayResults.GetPages.Size = 1 Then
'		BBCodeView1.mBase.SetLayoutAnimated(0,mBase.Left,BBcIndexes.mBase.top,BBCodeView1.mBase.Width - 20dip,BBCodeView1.mBase.Parent.Height + BBcIndexes.mBase.Height - BBLabel1.mBase.Height - BBCodeView1.mBase.Top)
'		Else
'		BBCodeView1.mBase.SetLayoutAnimated(0,mBase.Left,BBcIndexes.mBase.top + BBcIndexes.mBase.Height,BBCodeView1.mBase.Width - 20dip,BBCodeView1.mBase.Parent.Height - BBcIndexes.mBase.Height - BBLabel1.mBase.Height - BBCodeView1.mBase.Top)
'	End If
	
	BBLabel1.Text = DisplayResults.GetHeader
	BBcIndexes.Text = ""
	BBcIndexes.Text =  DisplayResults.GetWorkingBookmarks(CurrentPageNo)
	BBCodeView1.Text =  DisplayResults.GetPage(CurrentPageNo)
	BBCodeView1.sv.ScrollViewOffsetY = 0
	NumberSpinnerCV1.MaxValue = DisplayResults.PageCount + 1
	NumberSpinnerCV1.Value = 1
	lblPageCount.Text = " / " & (DisplayResults.PageCount + 1)
	
End Sub

'Clear data from all views
Public Sub ClearData
	BBCodeView1.Text = ""
	BBLabel1.Text = "."
	BBcIndexes.Text = ""
	NumberSpinnerCV1.MaxValue = 1
	lblPageCount.Text = " / " & (0)
	LibraryName = ""
	CurrentPageNo = 0
	mCurrentFileName = ""
	ProcessXML.ClearData
End Sub

'Get all pages as HTML
Public Sub AsHTMLList As List
	Return DisplayResults.CreatePages(LibraryName,"HTML",cbComments.Checked)
End Sub

'Get the css for the HTML pages
Public Sub getCSS As String
	Return DisplayResults.CSS
End Sub

'Get the filename that the pages are expecting for the CSS file
Public Sub getCSSFileName As String
	Return DisplayResults.CSSFileName
End Sub

Private Sub BBcodeView1_LinkClicked (URL As String)
	NumberSpinnerCV1.Value = URL + 1
	CurrentPageNo = URL
	BBcIndexes.Text =  DisplayResults.GetWorkingBookmarks(CurrentPageNo)
	BBCodeView1.Text =  DisplayResults.GetPage(CurrentPageNo)
	BBCodeView1.sv.ScrollViewOffsetY = 0
End Sub
Private Sub BBcIndexes_LinkClicked (URL As String)
	NumberSpinnerCV1.Value = URL + 1
	CurrentPageNo = URL
	BBcIndexes.Text =  DisplayResults.GetWorkingBookmarks(CurrentPageNo)
	BBCodeView1.Text =  DisplayResults.GetPage(CurrentPageNo)
	BBCodeView1.sv.ScrollViewOffsetY = 0
End Sub

Private Sub NumberSpinnerCV1_ValueChanged(Value As Double,AutoUpdate As Boolean)
	CurrentPageNo = Value - 1
	BBcIndexes.Text =  DisplayResults.GetWorkingBookmarks(CurrentPageNo)
	BBCodeView1.Text =  DisplayResults.GetPage(CurrentPageNo)
	BBCodeView1.sv.ScrollViewOffsetY = 0
End Sub

'Get the current page no
Public Sub getPageNo As Int
	Return CurrentPageNo
End Sub

'Get the current output mode
Public Sub getOutputMode As String
	Return mOutputMode
End Sub

'Get the current loaded filename
Public Sub getCurrentFileName As String
	Return mCurrentFileName
End Sub

'Set the output mode for the next display pass
Public Sub setOutputMode(OutputMode As String)
	mOutputMode = OutputMode
End Sub

Private Sub cbComments_CheckedChange(Checked As Boolean)
	If DisplayResults.CreatePages(LibraryName,mOutputMode,Checked).Size = 0 Then Return
	BBCodeView1.Text =  DisplayResults.GetPage(CurrentPageNo)
End Sub

Private Sub btnBBC2Clip_Click
	GetExportBBCodePage(False)
End Sub

'Get the forum friendly BBCode to the clipboard or optionally save to a file
Public Sub GetExportBBCodePage(Save As Boolean)
	Dim L As List = DisplayResults.CreatePages(LibraryName,DisplayResults.OUTPUTMODE_BBCODEEXPORT,cbComments.Checked)
	If L.IsInitialized = False Or L.Size = 0 Then Return
	
	
	Dim PageStr As String
	Dim Class As ClassType
	Dim FN As String
				
	If L.Size > 1 Then
		If CurrentPageNo = 0 Then
			Dialog.Title = "Save BBCode"
			Wait For(Dialog.Show("Cannot save code for index page","OK","","")) Complete (Resp As Int)
			Return
		Else
			PageStr  = L.Get(CurrentPageNo - 1)
			Class = ProcessXML.Library.Classes.Get(CurrentPageNo - 1)
			If Class.ShortName = "" Then
				FN = Class.Name
			Else
				FN = Class.ShortName
			End If
		End If
	Else
		PageStr = L.Get(CurrentPageNo)
		Class = ProcessXML.Library.Classes.Get(CurrentPageNo)
		If Class.ShortName = "" Then
			FN = Class.Name
		Else
			FN = Class.ShortName
		End If
	End If
	If Save Then
		Dim FC As FileChooser
		FC.Initialize
		FC.InitialDirectory = UserOptions_Static.GetUserOptionDefault("ExportBBCodePage",GetSystemProperty("user.home","C:\"))
		FC.Title = "Export BBcode Page"
		FC.InitialFileName =  FN & ".txt"
		FC.SetExtensionFilter("Txt File",Array("*.txt"))
		Dim FileName As String = FC.ShowSave(mForm)
		If FileName = "" Then Return
		UserOptions_Static.PutUserOption("ExportBBCodePage",File.GetFileParent(FileName))
				
		File.WriteString("",FileName,PageStr)
	Else
		FX.Clipboard.SetString(PageStr)
		Dialog.Title = "Export BBCode"
		Wait For (Dialog.Show("Code set on clipboard","OK","","")) Complete (Resp As Int)
	End If
End Sub