﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=7.8
@EndOfDesignText@
Sub Class_Globals
	Private fx As JFX
	Private mEventName As String 'ignore
	Private mCallBack As Object 'ignore
	Private mBase As B4XView
	
	
	Private lblGuiToolPath As B4XView
	Private lbl7ZipPath As B4XView
	Private lblWinzipPath As B4XView
	Private lblArchiveSet As B4XView
	Private rbJDK As RadioButton
	Private rb7Zip As RadioButton
	Private rbWinZip As RadioButton
	Private XUI As XUI
	Private mForm As Form
	Private btnGuiTool As Button
	Private btn7Zip As Button
	Private btnWinZip As Button
	Private lblJDKAvail As B4XView
	Private lblMultiManifestPath As Label
	Private btnMMPath As Button
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(Callback As Object, EventName As String, Form As Form)
	mEventName = EventName
	mCallBack = Callback
	mBase = XUI.CreatePanel("Base")
	mBase.SetLayoutAnimated(0, 0, 0, 600dip, 500dip)
	mBase.LoadLayout("ZipLoc")
	mForm = Form

	If BLD_Utils.GetJDKPath <> "" Then
		lblJDKAvail.Text = "Available"
	Else
		lblJDKAvail.Text = "Unavailable"
	End If
	
	BLD_Utils.SetEllipses(lblGuiToolPath)
	BLD_Utils.SetEllipses(lbl7ZipPath)
	BLD_Utils.SetEllipses(lblWinzipPath)
	
	lblGuiToolPath.Text = UserOptions_Static.GetUserOptionDefault("ZipFileLoc", "Not Set")
	lbl7ZipPath.Text = UserOptions_Static.GetUserOptionDefault("7ZipFileLoc", "Not Set")
	lblWinzipPath.Text = UserOptions_Static.GetUserOptionDefault("WinZipFileLoc", "Not Set")
	lblMultiManifestPath.Text = UserOptions_Static.GetUserOptionDefault("MultiManifestPath", "Not Set")
	
	Select UserOptions_Static.GetUserOptionDefault("ArchiveMethod","JDK")
		Case "JDK"
			rbJDK.Selected = True
		Case "7Zip"
			rb7Zip.Selected = True
		Case "WinZip"
			rbWinZip.Selected = True
		Case Else
			rbJDK.Selected = True
	End Select
		
End Sub

Public Sub GetBase As B4XView
	Return mBase
End Sub

'Manage the file choosers
Private Sub btnFileChooser_Click
	
	Dim btn As Button = Sender
	
	Dim FC As FileChooser
	FC.Initialize
	
	Dim FileName As String
	
	Select btn
		Case btnGuiTool
			FC.Title = "Select location of Zip Tool GUI version"
			FC.InitialDirectory = UserOptions_Static.GetUserOptionDefault("ZipFileLoc", "C:\")
		Case btn7Zip
			FC.Title = "Select location of 7Zip Tool CommandLine version"
			FC.InitialDirectory = UserOptions_Static.GetUserOptionDefault("7ZipFileLoc", "C:\")
		Case btnWinZip
			FC.Title = "Select location of WinZip Tool"
			FC.InitialDirectory = UserOptions_Static.GetUserOptionDefault("WinZipFileLoc", "C:\")
		Case btnMMPath
			Dim DC As DirectoryChooser
			DC.Initialize
			DC.Title = "Select location for Multi Project Manifests"
			DC.InitialDirectory = UserOptions_Static.GetUserOptionDefault("MultiManifestPath", "C:\")
	End Select
	
	If btn = btnMMPath Then
		FileName = DC.Show(mForm)
	Else
		If FC.InitialDirectory <> "C:\" Then FC.InitialDirectory = File.GetFileParent(FC.InitialDirectory)
		FC.SetExtensionFilter("Application File",Array("*.exe"))
		 FileName = FC.ShowOpen(mForm)
	End If
	
	
	If FileName = "" Then Return
	
	Select btn
		Case btnGuiTool
			UserOptions_Static.PutUserOption("ZipFileLoc",FileName)
			lblGuiToolPath.Text = FileName
		Case btn7Zip
			UserOptions_Static.PutUserOption("7ZipFileLoc",FileName)
			lbl7ZipPath.Text = FileName
		Case btnWinZip
			UserOptions_Static.PutUserOption("WinZipFileLoc",FileName)
			lblWinzipPath.Text = FileName
		Case btnMMPath
			UserOptions_Static.PutUserOption("MultiManifestPath",FileName)
			lblMultiManifestPath.Text = FileName
	End Select
	
	Main.CheckArchiveSet(UserOptions_Static.GetUserOptionDefault("ArchiveMethod","JDK"),lblArchiveSet)
End Sub


'Manage the archiver selection
Private Sub rb_SelectedChange(Selected As Boolean)
	Dim RB As RadioButton = Sender
	UserOptions_Static.PutUserOption("ArchiveMethod",RB.Tag)
	Main.CheckArchiveSet(RB.Tag, lblArchiveSet)
End Sub